/**
 * @file
 * VuoList_VuoSizingMode C type definition.
 *
 * @copyright Copyright © 2012–2014 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoSizingMode_H
#define VuoList_VuoSizingMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoSizingMode VuoList_VuoSizingMode
 * A list of @ref VuoSizingMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

#if defined(DOXYGEN) || !defined(VuoList_VuoSizingMode_TYPE_DEFINED)
/// @{
/**
 * A list of @ref VuoSizingMode elements.
 */
typedef const struct VuoList_VuoSizingMode_struct { void *l; } * VuoList_VuoSizingMode;
/// @}
#endif

/**
 * Creates a new list of @ref VuoSizingMode elements.
 */
VuoList_VuoSizingMode VuoListCreate_VuoSizingMode(void);

/**
 * Makes a shallow copy of `list` — its items are retained (not copied) by the new list.
 */
VuoList_VuoSizingMode VuoListCopy_VuoSizingMode(const VuoList_VuoSizingMode list);

/**
 * Returns the @ref VuoSizingMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoSizingMode VuoListGetValue_VuoSizingMode(const VuoList_VuoSizingMode list, const unsigned long index);

/**
 * Changes the @ref VuoSizingMode at @c index.
 * Index values start at 1.
 * If the list has no items, nothing is changed.
 * Attempting to change an out-of-bounds index changes the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
void VuoListSetValue_VuoSizingMode(const VuoList_VuoSizingMode list, const VuoSizingMode value, const unsigned long index);

/**
 * Inserts the `VuoSizingMode` immediately before `index`.
 * Index values start at 1.
 * Inserting at index 0 prepends the value to the list.
 * Inserting at an index beyond the last value in the list appends the value to the list.
 */
void VuoListInsertValue_VuoSizingMode(const VuoList_VuoSizingMode list, const VuoSizingMode value, const unsigned long index);

/**
 * Prepends @c value to @c list.
 */
void VuoListPrependValue_VuoSizingMode(VuoList_VuoSizingMode list, const VuoSizingMode value);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoSizingMode(VuoList_VuoSizingMode list, const VuoSizingMode value);

/**
 * Swaps the value at `indexA` with the value at `indexB`.
 */
void VuoListExchangeValues_VuoSizingMode(VuoList_VuoSizingMode list, const unsigned long indexA, const unsigned long indexB);

/**
 * Generates a random permutation of `list`.
 *
 * `chaos` ranges from 0 to 1.  When `chaos` is 1, a full Fisher–Yates shuffle is performed.  When less than 1, fewer iterations are performed.
 */
void VuoListShuffle_VuoSizingMode(VuoList_VuoSizingMode list, const double chaos);

/**
 * Reverses the order of the items in `list`.
 */
void VuoListReverse_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes items from the list except those in the range specified by `startIndex` and `itemCount`.
 */
void VuoListCut_VuoSizingMode(VuoList_VuoSizingMode list, const signed long startIndex, const unsigned long itemCount);

/**
 * Removes the first value from @c list.
 */
void VuoListRemoveFirstValue_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoSizingMode(VuoList_VuoSizingMode list);

/**
 * Removes the `VuoSizingMode` at `index`.
 * Index values start at 1.
 * Attempting to remove index 0 or an index beyond the last value in the list has no effect.
 */
void VuoListRemoveValue_VuoSizingMode(VuoList_VuoSizingMode list, const unsigned long index);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoSizingMode(const VuoList_VuoSizingMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoSizingMode VuoList_VuoSizingMode_makeFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoSizingMode_getJson(const VuoList_VuoSizingMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoSizingMode_getSummary(const VuoList_VuoSizingMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoSizingMode VuoList_VuoSizingMode_makeFromString(const char *str);
char * VuoList_VuoSizingMode_getString(const VuoList_VuoSizingMode value);
/// @}

/**
 * @}
 */

#endif
